////////////////////////////////////////////////////////////////////////////
// 
// File: fog.txt
// 
// Author: Frank Luna (C) All Rights Reserved
//
// System: AMD Athlon 1800+ XP, 512 DDR, Geforce 3, Windows XP, MSVC++ 7.0 
//
// Desc: Effect file that handles device states for linear vertex fog.
//          
////////////////////////////////////////////////////////////////////////////

// 
// Effect
//

int color;
float exp2;
float start;
float end;

technique Fog
{
    pass P0
    {
        //
        // Set Misc render states.

        pixelshader      = null;
        vertexshader     = null;
        fvf              = XYZ | Normal;
        Lighting         = true;
        NormalizeNormals = true;
        SpecularEnable   = true;

        //
        // Fog States
		
		FogVertexMode	= EXP2;
		FogDensity		= exp2;
		 
		FogColor		= color;
        FogEnable		= true;       // enable       	
	}
	
	pass P1
	{
		pixelshader      = null;
        vertexshader     = null;
        fvf              = XYZ | Normal;
        Lighting         = true;
        NormalizeNormals = true;
        SpecularEnable   = true;
        
		FogVertexMode	= LINEAR; // linear fog function
		FogStart		= start;  // fog starts 50 units away from viewpoint
		FogEnd			= end; // fog ends 300 units away from viewpoint
	        
		FogColor		= color;
        FogEnable		= true;       // enable
    }
}
