#ifndef _PARAMETER_H_
#define _PARAMETER_H_

#include <windows.h>
#include <mmsystem.h>
#include <assert.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <d3dx9math.h>
#include <d3d9types.h>

struct Option_Snow
{
	bool _using;
	
	int number;
	float size;
	D3DXVECTOR3 min;
	D3DXVECTOR3 max;
};

struct Option_Fog
{
	enum Fog_Style
	{
		Linear = 1,
		Exp2 = 2,
		Layer = 3
	};

	UINT color;

	float fog_start, fog_end;
	float exp2;

	bool _using;
	Fog_Style style;
};

struct Option_Ocean
{
	LPWSTR BumpmapFile;
	D3DXVECTOR2 trxtureScale;
	
	float waveFreq;
	float waveAmp;
	float bumpscale;

	D3DXVECTOR2 bumpspeed;
	D3DXVECTOR4 deepcolor;
	D3DXVECTOR4 shallowcolor;
	D3DXVECTOR4 reflectcolor;

	float reflactamount;
	float reflactblur;
	float fresenlpow;
	float fresenlbias;
	float hdrMulti;

	bool AlphaLayer;
	bool _using;

	int OceanSize_W;
	int OceanSize_H;

	D3DXVECTOR3 Position;
};


struct Option_Play
{
	enum _Camera
	{
		FPS = 1,
		CRAFT = 3,
		MMORPG = 2
	};

	enum _SinglePass
	{
		Single = true,
		Multi = false
	};

	enum _Anisotropy
	{
		AnisoX1 = 1,
		AnisoX2 = 2,
		AnisoX4 = 4,
		AnisoX8 = 8,
		AnisoX16 = 16,
		AnisoX32 = 32,
		AnisoX64 = 64
	};


	D3DFILLMODE fillmode;
	D3DTEXTUREFILTERTYPE mag;
	D3DTEXTUREFILTERTYPE pow;
	D3DTEXTUREFILTERTYPE mip;
	D3DTEXTUREOP color;
	
	_Camera camera;
	_SinglePass pass;
	_Anisotropy aniso;
};

struct Option
{
	Option_Fog		_Fog;
	Option_Ocean	_Ocean;
	Option_Play		_Play;
	Option_Snow		_Snow;
	bool Run;
};
#endif