#include "../../Source/MFC_Core/stdafx.h"
#include "CG_Ocean.h"
//#define fake

// 
CG_Ocean::CG_Ocean()
{
	m_pD3DDevice			= NULL;
	m_pVertexBuffer			= NULL;
	m_Texture_OceanBump		= NULL;
	m_Texture_Sky			= NULL;
	m_pVertexDeclaration	= NULL;

	vertex_cnt_x = 2;
	vertex_cnt_z = 2;
}

// Ҹ
CG_Ocean::~CG_Ocean()
{
	cgD3D9SetDevice(NULL);
	cgDestroyProgram(g_CGprogram_vertex);
	cgDestroyProgram(g_CGprogram_pixel);
	cgDestroyContext(g_CGcontext);

	if( m_Texture_OceanBump != NULL ) 
		m_Texture_OceanBump->Release(); 

	if( m_pVertexBuffer != NULL )
		m_pVertexBuffer->Release();

	if( m_pIndexBuffer != NULL)
		m_pIndexBuffer->Release();
}

// ó ʱȭ κ
bool CG_Ocean::Init(LPDIRECT3DDEVICE9 pDevice, D3DXVECTOR3 position, float Width, float Height,
					const LPWSTR WaterTextureName, LPDIRECT3DTEXTURE9 *SkyTexture)
{
	m_pD3DDevice = pDevice;
	m_Position = position;
	m_Position.x += (Width/2);
	m_Position.z += (Height/2);

	// ϴ ؽ ε
	m_Texture_Sky = SkyTexture;

	D3DXCreateTextureFromFile( m_pD3DDevice, WaterTextureName, &m_Texture_OceanBump );
	
	if(!Create_Vertex(Width, Height))
	{
		return false;
	}
	// cg α׷ ε
#ifndef fake
	if(!Create_CG("Effect/CG/OceanEffect.cg"))
#else
	if(!Create_CG("Effect/Shader/sky.vsh"))
#endif
	{
		return false;
	}

	return true;
}

// ٴ ǥ ؽ 
bool CG_Ocean::Create_Vertex(float Width, float Height)
{
/*	CLitVertex g_quadVertices[4];

	Width /= 2;
	Height /= 2;

	g_quadVertices[0] = CLitVertex( -Width, 0.0f,  Height,  0x0,  0.0f, 0.0f);
	g_quadVertices[1] = CLitVertex(  Width, 0.0f,  Height,  0x0,  1.0f, 0.0f);
	g_quadVertices[2] = CLitVertex( -Width, 0.0f, -Height,  0x0,  0.0f, 1.0f);
	g_quadVertices[3] = CLitVertex(  Width, 0.0f, -Height,  0x0,  1.0f, 1.0f);
	
	
	if(	FAILED( m_pD3DDevice->CreateVertexBuffer( 4*sizeof(CLitVertex), D3DUSAGE_WRITEONLY, 
		LITVERTEX_FVF, D3DPOOL_DEFAULT, &m_pVertexBuffer, NULL )))
	{
		return false;
	}

	void *pVertices = NULL;

	m_pVertexBuffer->Lock( 0, sizeof(g_quadVertices), (void**)&pVertices, 0 );
	memcpy( pVertices, g_quadVertices, sizeof(g_quadVertices) );
	m_pVertexBuffer->Unlock();
*/

	CLitVertex *g_quadVertices;
	
	g_quadVertices = new CLitVertex[vertex_cnt_x * vertex_cnt_z]; 
	
	int i=0;
	float size_w = Width/(vertex_cnt_x-1);
	float size_h = Height/(vertex_cnt_z-1);

	Width /= 2;
	Height /= 2;	
	for(int z=0; z < vertex_cnt_z; z++)
	{
		for(int x=0; x < vertex_cnt_x; x++)
		{
			g_quadVertices[i] = CLitVertex((x*size_w) - Width, 0, (z*size_h) - Height, 0xff0000ff, 0.0f, 0.0f);
			
			if(x%2)
				g_quadVertices[i].tu = 1.0f;
			else
				g_quadVertices[i].tu = 0.0f;

			if(z%2)
				g_quadVertices[i].tv = 1.0f;
			else
				g_quadVertices[i].tv = 0.0f;

			++i;
		}
	}

	if(	FAILED( m_pD3DDevice->CreateVertexBuffer( vertex_cnt_x*vertex_cnt_z*sizeof(CLitVertex), D3DUSAGE_WRITEONLY, 
		LITVERTEX_FVF, D3DPOOL_DEFAULT, &m_pVertexBuffer, NULL )))
	{
		return false;
	}

	void *pVertices = NULL;

	m_pVertexBuffer->Lock( 0, sizeof(CLitVertex)*vertex_cnt_x*vertex_cnt_z, (void**)&pVertices, 0 );
	memcpy( pVertices, g_quadVertices, sizeof(CLitVertex)*vertex_cnt_x*vertex_cnt_z );
	m_pVertexBuffer->Unlock();

	delete []g_quadVertices; 

	// ε 
	m_pD3DDevice->CreateIndexBuffer( vertex_cnt_x*vertex_cnt_z*6 * sizeof(CLitVertex), D3DUSAGE_WRITEONLY, D3DFMT_INDEX16, D3DPOOL_MANAGED,
									&m_pIndexBuffer, NULL);

	WORD* indices = 0;
	m_pIndexBuffer->Lock(0, 0, (void**)&indices, 0);

	i=0;
	for(int z=0; z < vertex_cnt_z-1; ++z)
	{
		for(int x=0; x < vertex_cnt_x-1; ++x)
		{
			// 1
			indices[i++] = x+(z*vertex_cnt_x);
			indices[i++] = x+((z+1)*vertex_cnt_x);
			indices[i++] = x+((z+1)*vertex_cnt_x) + 1;
			indices[i++] = x+(z*vertex_cnt_x);
			indices[i++] = x+(z*vertex_cnt_x) + 1;
			indices[i++] = x+((z+1)*vertex_cnt_x) + 1;
		}
	}

	m_pIndexBuffer->Unlock();

	return true;
}


bool CG_Ocean::Create_CG(LPCSTR CGFile)
{
	//--------------------------------------------------------------------
	// CG ʱȭ 
	// Create the context...
	g_CGcontext = cgCreateContext();

	//
	// Since we're using Cg's expanded interface, we'll need to pass the 
	// Direct3D device to Cg.
	//
	cgD3D9SetDevice( m_pD3DDevice );

	//
	// Determine the best vertex and pixel profiles to use...
	//
	// ɼ ߿... ̰ ȸ ȵư..
	CGprofile vertexProfile = CG_PROFILE_VS_1_1;
	CGprofile pixelProfile  = cgD3D9GetLatestPixelProfile();

	//
	// Grab the optimal options for each profile...
	//

	// Grab the optimal options for each profile...
	const char **vertexOptions[] =
	{
		cgD3D9GetOptimalOptions( vertexProfile ), NULL,
	};
	const char **pixelOptions[] =
	{
		cgD3D9GetOptimalOptions( pixelProfile ), NULL,
	};

	//
	// Create the vertex and pixel shaders...
	//

	g_CGprogram_vertex = cgCreateProgramFromFile( g_CGcontext,
												CG_SOURCE,
												CGFile,
												vertexProfile,
												"main_vs",
												*vertexOptions );

	g_CGprogram_pixel = cgCreateProgramFromFile( g_CGcontext,
												CG_SOURCE,
												CGFile,
												pixelProfile,
												"main_fs",
												*pixelOptions );

	//
	// If your program uses explicit binding semantics (like this one), 
	// you can create a vertex declaration using those semantics.
	//
	D3DVERTEXELEMENT9 declaration[] =
	{
		{ 0, 0,  D3DDECLTYPE_FLOAT3,   D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0, 12, D3DDECLTYPE_D3DCOLOR, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR,    0 },
		{ 0, 16, D3DDECLTYPE_FLOAT2,   D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
		D3DDECL_END()
	};

	//
	// Ensure the resulting declaration is compatible with the shader...
	//
	cgD3D9ValidateVertexDeclaration( g_CGprogram_vertex, declaration );
	m_pD3DDevice->CreateVertexDeclaration( declaration, &m_pVertexDeclaration );

	//
	// Load the programs using Cg's expanded interface...
	//
	// When the second parameter is set to TRUE, shadowing is enabled. This
	// will allow parameters like our g_CGparam_constColor to be set once and
	// reused with out constantly setting it over and over again.
	//
	cgD3D9LoadProgram( g_CGprogram_vertex, TRUE, 0 );
	cgD3D9LoadProgram( g_CGprogram_pixel, TRUE, 0 );

	//
	// Bind some parameters by name so we can set them later...
	//
	// Ķ 
#ifndef fake	
	g_CGparam_WorldViewProj = cgGetNamedParameter( g_CGprogram_vertex, "WorldViewProj" );
	g_CGparam_BumpScale		= cgGetNamedParameter( g_CGprogram_vertex, "BumpScale" );
	g_CGparam_bumpSpeed		= cgGetNamedParameter( g_CGprogram_vertex, "bumpSpeed" );
	g_CGparam_textureScale	= cgGetNamedParameter( g_CGprogram_vertex, "textureScale" );
	g_CGparam_time			= cgGetNamedParameter( g_CGprogram_vertex, "time" );
	g_CGparam_waveFreq		= cgGetNamedParameter( g_CGprogram_vertex, "waveFreq" );
	g_CGparam_waveAmp		= cgGetNamedParameter( g_CGprogram_vertex, "waveAmp" );
	g_CGparam_EyePosition	= cgGetNamedParameter( g_CGprogram_vertex, "eyePosition" );


	g_CGparam_deepColor		= cgGetNamedParameter( g_CGprogram_pixel, "deepColor" );
	g_CGparam_shallowColor	= cgGetNamedParameter( g_CGprogram_pixel, "shallowColor" );
	g_CGparam_waterAmount	= cgGetNamedParameter( g_CGprogram_pixel, "waterAmount" );
	g_CGparam_NormalMap		= cgGetNamedParameter( g_CGprogram_pixel, "NormalMap" );

	g_CGparam_SkyMap		= cgGetNamedParameter( g_CGprogram_pixel, "EnvironmentMap" );
	g_CGparam_reflectionColor	= cgGetNamedParameter( g_CGprogram_pixel, "reflectionColor" );
	g_CGparam_reflectionAmount	= cgGetNamedParameter( g_CGprogram_pixel, "reflectionAmount" );
	g_CGparam_reflectionBlur	= cgGetNamedParameter( g_CGprogram_pixel, "reflectionBlur" );
	g_CGparam_fresnelPower	= cgGetNamedParameter( g_CGprogram_pixel, "fresnelPower" );
	g_CGparam_fresnelBias	= cgGetNamedParameter( g_CGprogram_pixel, "fresnelBias" );
	g_CGparam_hdrMultiplier	= cgGetNamedParameter( g_CGprogram_pixel, "hdrMultiplier" );
#else

	g_CGparam_WorldViewProj = cgGetNamedParameter( g_CGprogram_vertex, "mvp" );
	g_CGparam_BumpScale		= cgGetNamedParameter( g_CGprogram_vertex, "HHH" );
	g_CGparam_bumpSpeed		= cgGetNamedParameter( g_CGprogram_vertex, "y2j" );
	g_CGparam_textureScale	= cgGetNamedParameter( g_CGprogram_vertex, "jon" );
	g_CGparam_time			= cgGetNamedParameter( g_CGprogram_vertex, "gold" );
	g_CGparam_waveFreq		= cgGetNamedParameter( g_CGprogram_vertex, "japp" );
	g_CGparam_waveAmp		= cgGetNamedParameter( g_CGprogram_vertex, "matt" );
	g_CGparam_EyePosition	= cgGetNamedParameter( g_CGprogram_vertex, "ep" );


	g_CGparam_deepColor		= cgGetNamedParameter( g_CGprogram_pixel, "walsom" );
	g_CGparam_shallowColor	= cgGetNamedParameter( g_CGprogram_pixel, "jerico" );
	g_CGparam_waterAmount	= cgGetNamedParameter( g_CGprogram_pixel, "phedi" );

	g_CGparam_reflectionColor	= cgGetNamedParameter( g_CGprogram_pixel, "hurrycane" );
	g_CGparam_reflectionAmount	= cgGetNamedParameter( g_CGprogram_pixel, "kein" );
	g_CGparam_reflectionBlur	= cgGetNamedParameter( g_CGprogram_pixel, "johnmorison" );
	g_CGparam_fresnelPower	= cgGetNamedParameter( g_CGprogram_pixel, "kalrito" );
	g_CGparam_fresnelBias	= cgGetNamedParameter( g_CGprogram_pixel, "apple" );
	g_CGparam_hdrMultiplier	= cgGetNamedParameter( g_CGprogram_pixel, "eric" );
	
	g_CGparam_NormalMap		= cgGetNamedParameter( g_CGprogram_pixel, "crison" );
	g_CGparam_SkyMap		= cgGetNamedParameter( g_CGprogram_pixel, "speir" );
#endif 
	//
	// Make sure our parameters have the expected size...
	//
	int s = cgD3D9TypeToSize(cgGetParameterType(g_CGparam_WorldViewProj));
	if(cgD3D9TypeToSize(cgGetParameterType(g_CGparam_WorldViewProj)) == 16 )
		return true;
	else
		return false;

}
//-----------------------------------------------------------------------------
// Name: setShaderConstants()
// Desc: 
//-----------------------------------------------------------------------------
void CG_Ocean::setShaderConstants(D3DXVECTOR3 eyePosition)
{
	// ٴǥ ׸ Ʈ  
	D3DXMATRIXA16 world, view, proj;
	m_pD3DDevice->GetTransform(D3DTS_WORLD , &world);
	D3DXMatrixTranslation( &world, m_Position.x, m_Position.y, m_Position.z);

	m_pD3DDevice->GetTransform(D3DTS_VIEW , &view);
	m_pD3DDevice->GetTransform(D3DTS_PROJECTION , &proj);

    D3DXMATRIXA16 worldViewProj = world * view * proj;
    D3DXMatrixTranspose( &worldViewProj, &worldViewProj );

	//
	// Set constants for the vertex shader...
	//
	// Load a combined world-view-projection matrix
	cgD3D9SetUniformMatrix( g_CGparam_WorldViewProj, &worldViewProj );

	//
	// Set constants for the pixel shader...
	//

	cgD3D9SetSamplerState(g_CGparam_NormalMap, D3DSAMP_ADDRESSU, D3DTADDRESS_WRAP);
	cgD3D9SetSamplerState(g_CGparam_NormalMap, D3DSAMP_ADDRESSV, D3DTADDRESS_WRAP);
	cgD3D9SetSamplerState(g_CGparam_NormalMap, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	cgD3D9SetSamplerState(g_CGparam_NormalMap, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	cgD3D9SetSamplerState(g_CGparam_NormalMap, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR);
	cgD3D9SetTextureWrapMode(g_CGparam_NormalMap, 0);

	cgD3D9SetTexture( g_CGparam_NormalMap, m_Texture_OceanBump );


	cgD3D9SetSamplerState(g_CGparam_SkyMap, D3DSAMP_ADDRESSU, D3DTADDRESS_CLAMP);
	cgD3D9SetSamplerState(g_CGparam_SkyMap, D3DSAMP_ADDRESSV, D3DTADDRESS_CLAMP);
	cgD3D9SetSamplerState(g_CGparam_SkyMap, D3DSAMP_ADDRESSW, D3DTADDRESS_CLAMP);
	cgD3D9SetSamplerState(g_CGparam_SkyMap, D3DSAMP_MINFILTER, D3DTEXF_LINEAR);
	cgD3D9SetSamplerState(g_CGparam_SkyMap, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR);
	cgD3D9SetSamplerState(g_CGparam_SkyMap, D3DSAMP_MIPFILTER, D3DTEXF_LINEAR);
	cgD3D9SetTextureWrapMode(g_CGparam_SkyMap, 1);

	cgD3D9SetTexture( g_CGparam_SkyMap, *m_Texture_Sky );

	//	static double dStartTime = timeGetTime();
	//	float fElpasedAppTime = (float)((timeGetTime() - dStartTime) * 0.001);
	static float time_0_x = 0.0f;
	time_0_x >= 25.0f ? time_0_x = -25.0f : time_0_x += 0.005f;
	cgD3D9SetUniform( g_CGparam_time, &time_0_x );

	//D3DXVECTOR3 eyePostion(0,0,4);
	cgD3D9SetUniform( g_CGparam_EyePosition, &eyePosition );
	cgD3D9SetUniform( g_CGparam_waveFreq, &g_Option._Ocean.waveFreq );
	cgD3D9SetUniform( g_CGparam_waveAmp, &g_Option._Ocean.waveAmp );
	cgD3D9SetUniform( g_CGparam_BumpScale, &g_Option._Ocean.bumpscale );
	cgD3D9SetUniform( g_CGparam_bumpSpeed, &g_Option._Ocean.bumpspeed );
	cgD3D9SetUniform( g_CGparam_textureScale, &g_Option._Ocean.trxtureScale );
	cgD3D9SetUniform( g_CGparam_deepColor, &g_Option._Ocean.deepcolor );
	cgD3D9SetUniform( g_CGparam_shallowColor, &g_Option._Ocean.shallowcolor );
	cgD3D9SetUniform( g_CGparam_reflectionColor, &g_Option._Ocean.reflectcolor );
	cgD3D9SetUniform( g_CGparam_reflectionAmount, &g_Option._Ocean.reflactamount );
	cgD3D9SetUniform( g_CGparam_reflectionBlur, &g_Option._Ocean.reflactblur );
	cgD3D9SetUniform( g_CGparam_fresnelPower, &g_Option._Ocean.fresenlpow );
	cgD3D9SetUniform( g_CGparam_fresnelBias, &g_Option._Ocean.fresenlbias );
	cgD3D9SetUniform( g_CGparam_hdrMultiplier, &g_Option._Ocean.hdrMulti );
}

bool CG_Ocean::Rander(D3DXVECTOR3 eyePosition)
{
	// ī޶  .  ִ ġ ٸ.. ׷Ƿ ش.
	D3DXVECTOR3 realPos = eyePosition;
	
	eyePosition = D3DXVECTOR3(eyePosition.x - m_Position.x, 5.05f, eyePosition.z - m_Position.z);

	// Setup alpha states for rendering water
	if(g_Option._Ocean.AlphaLayer)
	{
		m_pD3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE );
		m_pD3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1 );
		m_pD3DDevice->SetRenderState( D3DRS_SRCBLEND , D3DBLEND_SRCALPHA );
		m_pD3DDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
		m_pD3DDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
	}
	// Disable back face culling (so we see it from both sides) and zwriting
    m_pD3DDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );
    m_pD3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE );

	// CG  
	setShaderConstants(eyePosition);

	// ؽ ̴ 
	cgD3D9BindProgram( g_CGprogram_vertex );
	// ȼ ̴ 
	cgD3D9BindProgram( g_CGprogram_pixel );

	//     ؽĸ ׸
	m_pD3DDevice->SetFVF(LITVERTEX_FVF);
	m_pD3DDevice->SetVertexDeclaration( m_pVertexDeclaration );

	m_pD3DDevice->SetStreamSource( 0, m_pVertexBuffer, 0,sizeof(CLitVertex) );
//	m_pD3DDevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );
	m_pD3DDevice->SetIndices(m_pIndexBuffer);
	m_pD3DDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, vertex_cnt_x*vertex_cnt_z, 0, 2*(vertex_cnt_x-1)*(vertex_cnt_z-1));
	
	//  CG ׸ ̴  Ѵ..
	m_pD3DDevice->SetVertexShader( NULL );
	m_pD3DDevice->SetPixelShader( NULL );

	// Reset states
	if(g_Option._Ocean.AlphaLayer)
	{
		m_pD3DDevice->SetRenderState( D3DRS_ZWRITEENABLE, TRUE );
		m_pD3DDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );
		m_pD3DDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_CCW );
	}

    // Render alpha blended quad if we are underwater
    if ( realPos.y - 10.0f < m_Position.y )  
    {
		return true;
        
    } // End if render water effect
	return false;
}
