#ifndef	_CG_WATER_H_
#define _CG_WATER_H_

#include <windows.h>
#include <mmsystem.h>
#include <assert.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <Cg/Cg.h>
#include <Cg/CgD3D9.h>
#include "../../Source/3D_Core/CObject_DX.h"


class CG_Ocean
{
public:
	CG_Ocean();
	~CG_Ocean();

	// ʱȭ
	bool Init(LPDIRECT3DDEVICE9 pDevice, D3DXVECTOR3 position, float Width, float Height,
		const LPWSTR WaterTextureName, LPDIRECT3DTEXTURE9 *SkyTexture);

	// 
	bool Rander(D3DXVECTOR3 eyePosition);

private:
	// cg  
	void setShaderConstants(D3DXVECTOR3 eyePosition);
	bool Create_Vertex(float Width, float Height);
	bool Create_CG(const LPCSTR CGFile);

	/////////////////////////////////////////////////////
	// 
	LPDIRECT3DDEVICE9       m_pD3DDevice;						// ̽
	LPDIRECT3DVERTEXBUFFER9 m_pVertexBuffer;					// CG  ؽ..  ٴ ǥ
	LPDIRECT3DTEXTURE9      m_Texture_OceanBump;				// ٴ ǥ 
	LPDIRECT3DTEXTURE9      *m_Texture_Sky;						// ϴ ؽ... (ٴٿ ݻǴ   ʿ)	
	LPDIRECT3DVERTEXDECLARATION9 m_pVertexDeclaration;		

	D3DXVECTOR3				m_Position;							//  ǥ ġ

	int vertex_cnt_x, vertex_cnt_z;

	LPDIRECT3DINDEXBUFFER9		m_pIndexBuffer;

	//////////////////// CG  //////////////////////
	CGcontext   g_CGcontext;
	CGprogram   g_CGprogram_vertex;
	CGprogram   g_CGprogram_pixel;
	CGparameter g_CGparam_WorldViewProj;

	CGparameter g_CGparam_time;
	CGparameter g_CGparam_textureScale;
	CGparameter g_CGparam_waveFreq;
	CGparameter g_CGparam_waveAmp;
	CGparameter g_CGparam_BumpScale;
	CGparameter g_CGparam_bumpSpeed;
	CGparameter g_CGparam_EyePosition;

	CGparameter g_CGparam_NormalMap;
	CGparameter g_CGparam_SkyMap;
	CGparameter g_CGparam_deepColor;
	CGparameter g_CGparam_shallowColor;
	CGparameter g_CGparam_waterAmount;
	CGparameter g_CGparam_reflectionColor;
	CGparameter g_CGparam_reflectionAmount;
	CGparameter g_CGparam_reflectionBlur;
	CGparameter g_CGparam_fresnelPower;
	CGparameter g_CGparam_fresnelBias;
	CGparameter g_CGparam_hdrMultiplier;

};

#endif