#ifndef	_CG_WATER_H_
#define _CG_WATER_H_

#include <windows.h>
#include <mmsystem.h>
#include <assert.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <Cg/Cg.h>
#include <Cg/CgD3D9.h>

#define LITVERTEX_FVF   D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1
   
class CLitVertex
{
public:
    //-------------------------------------------------------------------------
    // Constructors & Destructors for This Class.
    //-------------------------------------------------------------------------
    CLitVertex( float fX, float fY, float fZ, ULONG ulDiffuse = 0xFF000000, float ftu = 0.0f, float ftv = 0.0f ) 
        { x = fX; y = fY; z = fZ; Diffuse = ulDiffuse; tu = ftu; tv = ftv; }
    
    CLitVertex() 
        { x = 0.0f; y = 0.0f; z = 0.0f; Diffuse = 0xFF000000; tu = 0.0f; tv = 0.0f; }

    //-------------------------------------------------------------------------
    // Public Variables for This Class
    //-------------------------------------------------------------------------
    float       x;          // Vertex Position X Component
    float       y;          // Vertex Position Y Component
    float       z;          // Vertex Position Z Component
    ULONG       Diffuse;    // Diffuse vertex colour component
    float       tu;         // Texture u coordinate
    float       tv;         // Texture v coordinate
};


class CG_Ocean
{
public:
	CG_Ocean();
	~CG_Ocean();

	// ʱȭ
	void Init(LPDIRECT3DDEVICE9 pDevice, D3DXVECTOR3 position, float Width, float Height,
					const LPWSTR WaterTextureName, LPDIRECT3DTEXTURE9 *SkyTexture);
	
	// 
	bool Rander(D3DXVECTOR3 eyePosition);

private:
	// cg  
	void setShaderConstants(D3DXVECTOR3 eyePosition);

	/////////////////////////////////////////////////////
	// 
	LPDIRECT3DDEVICE9       m_pD3DDevice;						// ̽
	LPDIRECT3DVERTEXBUFFER9 m_pVertexBuffer;					// CG  ؽ..  ٴ ǥ
	LPDIRECT3DTEXTURE9      m_Texture_OceanBump;				// ٴ ǥ 
	LPDIRECT3DTEXTURE9      *m_Texture_Sky;						// ϴ ؽ... (ٴٿ ݻǴ   ʿ)	
	LPDIRECT3DVERTEXDECLARATION9 m_pVertexDeclaration;		

	D3DXVECTOR3				m_Position;							//  ǥ ġ

	int gridsize_x, gridsize_y;
	LPDIRECT3DINDEXBUFFER9		surf_indicies;
	//////////////////// CG  //////////////////////
	CGcontext   g_CGcontext;
	CGprogram   g_CGprogram_vertex;
	CGprogram   g_CGprogram_pixel;
	CGparameter g_CGparam_WorldViewProj;

	CGparameter g_CGparam_time;
	CGparameter g_CGparam_textureScale;
	CGparameter g_CGparam_waveFreq;
	CGparameter g_CGparam_waveAmp;
	CGparameter g_CGparam_BumpScale;
	CGparameter g_CGparam_bumpSpeed;
	CGparameter g_CGparam_EyePosition;

	CGparameter g_CGparam_NormalMap;
	CGparameter g_CGparam_SkyMap;
	CGparameter g_CGparam_deepColor;
	CGparameter g_CGparam_shallowColor;
	CGparameter g_CGparam_waterAmount;
	CGparameter g_CGparam_reflectionColor;
	CGparameter g_CGparam_reflectionAmount;
	CGparameter g_CGparam_reflectionBlur;
	CGparameter g_CGparam_fresnelPower;
	CGparameter g_CGparam_fresnelBias;
	CGparameter g_CGparam_hdrMultiplier;

};

#endif
